<?

function mysession_check_islocalhost() {
 global $CN_CONFIG_ALLOWEDIPS;

 if( is_array( $CN_CONFIG_ALLOWEDIPS ) ) {
 return in_array( $_SERVER['REMOTE_ADDR'], $CN_CONFIG_ALLOWEDIPS );
 } else {
 if( $_SERVER['REMOTE_ADDR'] == '127.0.0.1' ) return true;
 }
 return false;
}









































function mysession_check($sid) {
 global $DEBUG;
 global $USER_NAME;
 global $USER_EMAIL;
 global $VAR;
 global $LANGUAGE;
 global $SESSION_SECRET;
 global $SESSION_ID;
 global $SESSION_TOKEN;
 global $SESSION_SECRET_COOKIE_NAME;

 
 
 
 
 
 
 
 
 
 list($token_id, $secret) = mysession_split_token($sid);
 if ( ! is_null($secret) ) {
 mysession_set_cookie($secret);
 }

 $row = mysession_fetch_session($sid, $_COOKIE[$SESSION_SECRET_COOKIE_NAME]);

 if (false === $row) {
 
 mysession_log_cookie_kick($sid);
 
 return false;
 }

 if (false === mysession_check_consistency($row)) {
 
 
 return false;
 }

 if (!$VAR) $VAR = $row["val"];

 
 
 $LANGUAGE = $row["language"];

 $SESSION_SECRET = $row["secret"];
 $SESSION_ID = $row["id"];
 $SESSION_TOKEN = mysession_create_token($SESSION_ID, $SESSION_SECRET);

 $userid = $row["user_id"];

 if ($DEBUG["session"]) {
 echo "session '$sid' has userid '$userid'!<br>";
 }
 
 if (!$userid || $userid == -1) {
 $USER_NAME = "anonymous";
 
 } else {
 $USER_NAME = $row["lastname"]." ".$row["firstname"];
 $USER_EMAIL = $row["email"];
 }

 return intval($userid);
}































function mysession_fetch_session($sid, $secret = null) {

 $sql = "SELECT systemsession.*,"
 . " systemuser.email,"
 . " systemuser.firstname,"
 . " systemuser.lastname"
 . " FROM systemsession"
 . " LEFT JOIN systemuser"
 . "        ON systemsession.user_id = systemuser.id";
 
 $split_token = mysession_split_token($sid);
 list($token_id, $token_secret) = $split_token;
 if (false === $split_token) {
 
 
 $sql .= " WHERE systemsession.id = " . sql_num($sid);
 } else {
 
 
 
 $sql .= " WHERE systemsession.id = " . sql_num($sid)
 . "    OR (    systemsession.id = " . sql_num($token_id)
 . "        AND systemsession.secret = " .sql_str($token_secret)
 . "       )";

 }

 $rs = query($sql);
 $row = $rs["arr"][0];

 
 
 
 if ( ( null !== $secret && $secret == $row["secret"] )
 || ( false !== $split_token && $token_secret == $row["secret"] ))
 {
 return $row;
 } else {
 return false;
 }
}

function mysession_check_consistency($session_vars) {
 global $DEBUG;
 global $SESSION_CHECK;
 global $SESSION_AGE;

 $de = $DEBUG["session"];

 
 if ($de) echo "ip ... ";
 if ($SESSION_CHECK["ip"] && $session_vars["ip"] != getenv("REMOTE_ADDR")) {
 return false;
 }
 if ($de) echo "ok!<br>";

 
 if ($de) echo "agent ... ";
 if ($SESSION_CHECK["agent"] && !mysession_check_islocalhost() && $session_vars["agent"] != getenv("HTTP_USER_AGENT")) {
 return false;
 }
 if ($de) echo "ok!<br>";

 
 if ($de) echo "time ... ";
 if ($session_vars["since"] < time() - $SESSION_AGE) {
 return false;
 }
 if ($de) echo "ok!<br>";

 return true;
}

function mysession_log_cookie_kick($sid) {
 global $DEBUG;
 global $FILEPATH;
 global $SESSION_SECRET_COOKIE_NAME;
 if ($DEBUG["session_cookie_kick"]) {
 
 $msg = "[" . date("Y-m-d H:i:s") . "]\n";
 $msg .= "COOKIE " . $_COOKIE[$SESSION_SECRET_COOKIE_NAME] . "\n";
 $msg .= "SID " . $sid . "\n";
 $msg .= "PROTOCOL: ". $_SERVER["SERVER_PROTOCOL"] . "\n";
 $msg .= "SERVERNAME: ". $_SERVER["SERVER_NAME"] . "\n";
 $msg .= "HTTP_HOST: ". $_SERVER["HTTP_HOST"] . "\n";
 $msg .= "REQUEST: " . $_SERVER["REQUEST_URI"] . "\n";
 $msg .= "POST DATA: \n";
 if (count($_POST) > 0) {
 while (list($k,$v)=each($_POST)) {
 $msg .= "$k=$v\n";
 }
 }
 $msg .= "\n";
 error_log ($msg, 3, "$FILEPATH/log/session_check_cookie.log");
 }
}


