<?

class CNContentmap {

 var $handles;

 function CNContentmap() {
 $this->loadDefaultHandles();
 
 }

 
 function loadDefaultHandles() {
 global $FEATURE, $CN_MAP_DB_SETTINGS, $CN_MAP_DBS, $CN_MAP_UPDATE_DB_SETTINGS, $CONTENTMAP_CHARSET, $CNMAP_NOTIFICATION_TABLE;
 $this->handles = array();

 if ($FEATURE["contentmap_handles"]) {
 echo "The feature contentmap_handles is deprecated and may not be used anymore.";
 exit(1);
 }
 if (is_array($CN_MAP_DB_SETTINGS)) {
 
 $this->handles["static"]["map"] = $CN_MAP_DB_SETTINGS;
 $this->handles["static"]["charset"] = $CONTENTMAP_CHARSET;
 $this->handles["static"]["notify"] = $CN_MAP_UPDATE_DB_SETTINGS;
 $this->handles["static"]["notification_table"] = $CNMAP_NOTIFICATION_TABLE;
 $this->handles["static"]["publish_files"] = $FEATURE["contentmap_files"];
 $this->handles["static"]["notification_queue"] = $FEATURE["cnmap_notification_queue"];
 }
 }
 
 


 function doPublishContentmap($node_id) {
 global $FEATURE, $DEBUG;
 static $node_publish;
 
 if (!$FEATURE["contentmap"]) return 0;
 
 if (!isset($node_publish[$node_id])) {
 $sql = "SELECT publish_contentmap FROM node WHERE id = ".sqlf_tl_num($node_id);
 $rs = query($sql, true);
 $node_publish[$node_id] = $rs["arr"][0]["publish_contentmap"];
 }

 if (!$node_publish[$node_id]) return 0;
 
 $key = $this->_getNodeHandle($node_id);
 return is_array($this->handles[$key]["map"]) ? 1 : 2;
 }

 


 function doPublishNotificationsByKey($key) {
 global $FEATURE, $DEBUG;
 
 if (!$FEATURE["contentmap"] || !$FEATURE["cnmap_updatenotification"]) return 0;

 if (!$this->handles[$key]["notification_table"]) return 0;

 return is_array($this->handles[$key]["notify"]) ? 1 : 2;
 }
 
 function doPublishNotifications($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->doPublishNotificationsByKey($key);
 }
 
 function doPublishNotificationQueue($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->handles[$key]["publish_files"];
 }

 function doPublishNotificationQueueByKey($key) {
 return $this->handles[$key]["notification_queue"];
 }
 
 function doPublishFiles($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->handles[$key]["publish_files"];
 }
 
 function getCnMapCharset($node_id) {
 global $FEATURE;
 if (!$FEATURE["contentmap_charset"]) return "";
 $key = $this->_getNodeHandle($node_id);
 return $this->handles[$key]["charset"];
 }

 function getCnMapNotificationTable($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->handles[$key]["notification_table"];
 }
 
 function &getNotificationHandle($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->_getCnMapHandleByKey($key, "notify");
 }

 function &getCnMapHandle($node_id) {
 $key = $this->_getNodeHandle($node_id);
 return $this->_getCnMapHandleByKey($key, "map");
 }

 function &getCnMapHandleByKey($key) {
 return $this->_getCnMapHandleByKey($key, "map");
 }

 
 function getCnMapNotificationTableByKey($key) {
 return $this->handles[$key]["notification_table"];
 }
 
 function startTransaction($node_id = 0) {
 if ($node_id) {
 $key = $this->_getNodeHandle($node_id);
 $this->_startTransaction($key);
 } else {
 $keys = array_keys($this->handles);
 foreach ($keys as $key) {
 $this->_startTransaction($key);
 }
 } 
 }

 function commit($node_id = 0) {
 if ($node_id) {
 $key = $this->_getNodeHandle($node_id);
 $this->_commit($key);
 } else {
 $keys = array_keys($this->handles);
 foreach ($keys as $key) {
 $this->_commit($key);
 }
 } 
 }

 function getConfigurations($staticName = "") {
 global $FEATURE;
 if ($FEATURE["contentmap_handles"]) {
 $list = array();
 foreach ($this->handles as $key=>$val) {
 if (!ereg("^key_(.+)$", $key, $regs)) continue;
 $list[$key] = $regs[1];
 }
 return $list; 
 } else {
 return array("static"=>$staticName);
 }
 }
 
 function getNodeIds() {
 if (!$FEATURE["contentmap"]) return array();
 $sql = "SELECT id FROM node WHERE publish_contentmap = 1";
 $rs = query($sql,1);
 $list = array();
 foreach ($rs["arr"] as $key=>$val) $list[] = $val["id"];
 return $list;
 }
 
 
 
 function _startTransaction($key) {
 $handle =& $this->_getCnMapHandleByKey($key, "map");
 if (!mydb_is_handle($handle)) return false;
 if ($handle["dbtype"] == "mysql") {
 query( "start transaction", $handle);
 }
 }
 
 function _commit($key) {
 $handle =& $this->_getCnMapHandleByKey($key, "map");
 if (mydb_is_handle($handle)) {
 
 if ($handle["dbtype"] == "oci") {
 ocicommit( $handle["handle"] );
 } else {
 query( "commit", $handle );
 }
 }
 $notify =& $this->getCnMapHandleByKey($key, "notify");
 if (mydb_is_handle($notify)) {
 
 if ($notify["dbtype"] == "oci") {
 ocicommit( $notify["handle"] );
 } else {
 query( "commit", $notify );
 }
 }
 }
 
 function &_getCnMapHandleByKey($key, $db) {
 static $handleHash;
 if (isset($handleHash[$key][$db])) return $handleHash[$key][$db];
 
 
 if (!is_array($this->handles[$key][$db])) $handleHash[$key][$db] = false;
 else $handleHash[$key][$db] = mydb_connect($this->handles[$key][$db]);
 
 return $handleHash[$key][$db];
 }
 
 


 function _getNodeHandle($node_id) {
 global $FEATURE;
 if ($FEATURE["contentmap_handles"]) {
 $handle = $this->getNodeHandle($node_id);
 return $handle ? "key_$handle" : "static" ;
 } else {
 return "static";
 }
 }

 
 function getNodeHandleByKey($key) {
 if ($key == "static") return "";
 if (ereg("^key_(.+)$", $key, $regs)) return $regs[1];
 return false;
 }

 function getNodeHandleKey($node_id) {
 return $this->_getNodeHandle($node_id);
 }

 
 function getNodeHandle($node_id) {
 static $handle;
 if (isset($handle[$node_id])) return $handle[$node_id];

 $sql = "SELECT publish_contentmap, contentmap_handle FROM node WHERE id = ".sqlf_tl_num((int)$node_id);
 $rs = query($sql, true);
 $handle[$node_id] = $rs["arr"][0]["contentmap_handle"];
 
 return $handle[$node_id];
 }
 
}
 
?>
